// 5 g

// g
function [gg,pp]=ident_freq(t,om,data)
  ss = intsplin(t,data.*sin(om*t))*2/t(length(t));
  cc = intsplin(t,data.*cos(om*t))*2/t(length(t));
  gg = sqrt(ss^2+cc^2); pp=atan(cc,ss);
endfunction

// {[h}(̒Pʂ [rad/s])
function bode_rs(psys,w)
  wHz = w/2/%pi;
  frq = repfreq(psys,wHz); [db,phi] = dbphi(frq);
  subplot(211)
    plot2d1("oln",w,db)
    xgrid(), xtitle('{[h}','w [rad/s]','QC [dB]')
    xset('font size',3)
  subplot(212)
    plot2d1("oln",w,phi)
    xgrid(), xtitle('','w [rad/s]','ʑ [deg]')
    xset('font size',3)
endfunction

// Scilab 5.4 ==========
t=0:0.01:8;   // V~[VԂ̐ݒ
u=sin(5*t);   // g
P1st=syslin('c',1/(1+0.5*s));   // 1VXe
y=csim(u,t,P1st);   // ԉ̌vZ
plot2d(t,y,axesflag=1)   // \
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

caxes = gca();   // nh̎擾
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.children.children.thickness = 2;   // ̑
caxes.box = "on";

// Scilab 5.6 ==========
loadmatfile('fdata.txt','-ascii')   // f[^̓ǂݍ
t=fdata(:,1); u=fdata(:,2); y=fdata(:,3);  // ԂƎf[^
[gi,pi]=ident_freq(t,2*%pi*2.5,u)   // g
[go,po]=ident_freq(t,2*%pi*2.5,y)   // g

plot2d(t,[u,y],axesflag=1);
xgrid(), xtitle('','time [s]','u, y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

caxes = gca();   // nh̎擾
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.children.children(1).thickness = 2;   // ̑
caxes.children.children(1).foreground = 1;   // 
caxes.children.children(2).thickness = 2;   // ̑
caxes.children.children(2).foreground = 1;   // ̑
caxes.children.children(2).line_style = 7;   // _
caxes.box = "on";

// Scilab 5.7 ==========
P1st=syslin('c',1/(1+0.5*s));   // `B֐
nyquist(P1st,0,100)   // xNgO(0-100[Hz])
xgrid(), xtitle('xNgO','','')
xset('font size',3)   // tHgTCY̎w

caxes=gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.x_location = "origin";   // x_
caxes.y_location = "origin";   // y_
mtlb_axis([-0.2,1.2,-0.8,0.4]);   // ͈̔͂̐ݒ
caxes.isoview = "on";   // x y𓯈䗦ɂ

// Scilab 5.8 ==========
P1st=syslin('c',1/(1+s));   // `B֐
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
bode_rs(P1st,w);   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";
caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

// Scilab 5.9 ==========
P1st=syslin('c',1/(1+s));   // `B֐
black(P1st,0,100)   // QCEʑ}(0-100[Hz])
xgrid(), xtitle('QCEʑ}','ʑ [deg]','QC [dB]')
xset('font size',3)   // tHgTCY̎w

caxes=gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.box = "on";

// Scilab 5.11 ==========
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
Pdiff=syslin('c',s,1);   // vf̓`B֐
bode_rs(Pdiff,w);   // {[h}

cfig=gcf();   //@nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";
subplot(2,1,2); mtlb_axis([0.01,100,0,100]);   // ͈̔͂̐ݒ

// Scilab 5.13 ==========
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
Pint=syslin('c',1/s);   // ϕvf̓`B֐
bode_rs(Pint,w);   // {[h}

cfig=gcf();   //@nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";
subplot(2,1,2); mtlb_axis([0.01,100,-100,0]);   // ͈̔͂̐ݒ

// Scilab 5.14 ==========
t1=0:0.1:50; t2=0:0.01:5;   // V~[V
Pdiffa=syslin('c',s/(1+0.001*s));   // ߎvf
Pint=syslin('c',1/s);   // ϕvf
u1=sin(0.5*t1); u2=sin(5*t2);   // g
ydiff1=csim(u1,t1,Pdiffa); ydiff2=csim(u2,t2,Pdiffa);   // ԉ
yint1=csim(u1,t1,Pint); yint2=csim(u2,t2,Pint);   // ԉ
subplot(2,1,1);   // sin(0.5t)
plot2d(t1,[u1',ydiff1',yint1'],axesflag=1);   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
subplot(2,1,2);   // sin(5t)
plot2d(t2,[u2',ydiff2',yint2'],axesflag=1);   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

cfig=gcf();   //@nh̎擾
// subplot(2,1,2)
caxes1=cfig.children(1);   // nh
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.children.children(1).foreground = 1;   // 
caxes1.children.children(1).line_style = 7;   // _
caxes1.children.children(1).thickness=2;   // ̑ 2
caxes1.children.children(2).foreground = 1;   // 
caxes1.children.children(2).line_style = 1;   // 
caxes1.children.children(2).thickness=1;   // ̑ 1
caxes1.children.children(3).foreground = 1;   // 
caxes1.children.children(3).line_style = 1;   // 
caxes1.children.children(3).thickness=2;   // ̑ 2
caxes1.box = "on";

// subplot(2,1,1)
caxes2=cfig.children(2);   // nh
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.children.children(1).foreground = 1;   // 
caxes2.children.children(1).line_style = 7;   // _
caxes2.children.children(1).thickness=2;   // ̑ 2
caxes2.children.children(2).foreground = 1;   // 
caxes2.children.children(2).line_style = 1;   // 
caxes2.children.children(2).thickness=1;   // ̑ 1
caxes2.children.children(3).foreground = 1;   // 
caxes2.children.children(3).line_style = 1;   // 
caxes2.children.children(3).thickness=2;   // ̑ 2
caxes2.box = "on";

// Scilab 5.16 ==========
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
P1st=syslin('c',1/(1+s));   // `B֐
bode_rs(P1st,w);   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

// Scilab 5.17 ==========
t1=0:0.1:100; t2=0:0.01:5;   // V~[V
P1st=syslin('c',1/(1+s));   // `B֐
u1=sin(0.1*t1); u2=sin(5*t2);   // 
y1=csim(u1,t1,P1st); y2=csim(u2,t2,P1st);   // ԉ
subplot(2,1,1)   // sin(2*%pi*t/10)
plot2d(t1,[u1',y1'],axesflag=1);   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
subplot(2,1,2)   // sin(2*%pi*t/0.5)
plot2d(t2,[u2',y2'],axesflag=1);   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

cfig=gcf();   //@nh̎擾
// subplot(2,1,2)
caxes1=cfig.children(1);   // nh
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.children.children(1).foreground = 1;   // 
caxes1.children.children(1).line_style = 1;   // 
caxes1.children.children(1).thickness=2;   // ̑ 2
caxes1.children.children(2).foreground = 1;   // 
caxes1.children.children(2).line_style = 1;   // 
caxes1.children.children(2).thickness=1;   // ̑ 1
caxes1.box = "on";

// subplot(2,1,1)
caxes2=cfig.children(2);   // nh
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.children.children(1).foreground = 1;   // 
caxes2.children.children(1).line_style = 1;   // 
caxes2.children.children(1).thickness=2;   // ̑ 2
caxes2.children.children(2).foreground = 1;   // 
caxes2.children.children(2).line_style = 1;   // 
caxes2.children.children(2).thickness=1;   // ̑ 1
caxes2.box = "on";

// 1VXeɑ΂ߎ{[h} ==========
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
P1st=syslin('c',1/(1+s));   // `B֐
bode_rs(P1st,w);   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.children.children.line_style = 7;   // _
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.line_style = 7;   // _
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";
subplot(2,1,1)
plot([0.01,1,100],[0,0,-40],'-k')   // ߎ
mtlb_axis([0.01,100,-40,0]);
subplot(2,1,2)
plot([0.01,1/5,5,100],[0,0,-90,-90],'-k')   // ߎ

// Scilab 5.18 ==========
t=0:0.1:100;   // V~[V
P1st=syslin('c',1/(1+s));   // 1VXe
u0=sin(0.1*t);   // {g
u=sin(0.1*t)+0.5*sin(5*t);   // mCY
y=csim(u,t,P1st);   // ԉ
subplot(2,1,1)   // 
plot2d(t,[u',u0'],axesflag=1)   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
subplot(2,1,2)   // o
plot2d(t,[y',u0'],axesflag=1)   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children(1).foreground = 1;   // 
caxes1.children.children(1).line_style = 1;   // 
caxes1.children.children(1).thickness=2;   // ̑ 2
caxes1.children.children(2).foreground = 1;   // 
caxes1.children.children(2).line_style = 1;   // 
caxes1.children.children(2).thickness=1;   // ̑ 1
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children(1).foreground = 1;   // 
caxes2.children.children(1).line_style = 1;   // 
caxes2.children.children(1).thickness=2;   // ̑ 2
caxes2.children.children(2).foreground = 1;   // 
caxes2.children.children(2).line_style = 1;   // 
caxes2.children.children(2).thickness=1;   // ̑ 1
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

// Scilab 5.20 ==========
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
Pp1=syslin('c',(1+s)/(1+10*s));   // `B֐
bode_rs(Pp1,w);   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

Pp2=syslin('c',(1+10*s)/(1+s));   // `B֐
bode_rs(Pp2,w);   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

// Scilab 5.22 ==========
w=logspace(-1,1,300);   // pg(0.1-10[rad/s])
for zz=[0.05,0.1,0.3,0.7,1.0]
  P2nd=syslin('c',1/(s^2+2*zz*s+1));   // `B֐
  bode_rs(P2nd,w);   // {[h}
end
subplot(2,1,1)
mtlb_axis([0.1,10,-40,30])

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

subplot(2,1,1)
xstring(1,-10,'1.0')
xstring(1,-4,'0.7')
xstring(1,3,'0.3')
xstring(1,10,'0.1')
xstring(1,20,'0.05')
subplot(2,1,2)
xstring(0.3,-50,'1.0')
xstring(0.5,-50,'0.7')
xstring(0.65,-50,'0.5')
xstring(0.8,-50,'0.1')
xstring(1,-50,'0.05')

// Scilab 5.23 ==========
w=logspace(0,2,100);   // pg(1-100[rad/s])
P2nd=syslin('c',100/(s^2+6*s+100));   // `B֐
bode_rs(P2nd,w)   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

t=0:0.01:10;   // V~[V
y1=csim(sin(2*t),t,P2nd); y2=csim(sin(10*t),t,P2nd);   // ԉ
y3=csim(sin(30*t),t,P2nd);   // ԉ
plot2d(t,[y1',y2',y3'],axesflag=1)   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

caxes=gca();   // nh̎擾
caxes.children.children(1).foreground = 1;   // 
caxes.children.children(1).line_style = 1;   // 
caxes.children.children(1).thickness=1;   // ̑ 1
caxes.children.children(2).foreground = 1;   // 
caxes.children.children(2).line_style = 7;   // 
caxes.children.children(2).thickness=2;   // ̑ 2
caxes.children.children(3).foreground = 1;   // 
caxes.children.children(3).line_style = 1;   // 
caxes.children.children(3).thickness=2;   // ̑ 2
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.box = "on";

// Scilab 5.24 ==========
w=logspace(-2,1,100);   // pg(0.01-10[rad/s])
wHz = w/2/%pi;   // [rad/s]->[Hz]
Pn=syslin('c',10*(5*s+1)/(10*s+1)/(s+1));   // `B֐
frq=repfreq(Pn,wHz);   // g
[db,phi]=dbphi(frq);   // QCƈʑ̌vZ
plot2d1("oln",w,db)   // QC}̕`
xgrid(), xtitle('QC}','w [rad/s]','QC [dB]')
xset('font size',3)   // tHgTCY̎w

caxes=gca();   // nh̎擾
caxes.children.children.thickness=2;   // ̑ 2
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.box = "on";
mtlb_axis([0.01,10,-20,30])
plot([0.01,10],[20,20],'-k')
plot([0.01,0.1,1],[0,0,-20],'-k')
plot([0.01,1,10],[0,0,-20],'-k')
plot([0.01,0.2,6],[0,0,30],'-k')
plot([0.01,0.1,0.2,1,10],[20,20,14,14,-6],'-k')

xstring(0.22,21,'P1')
xstring(0.15,-3,'P2')
xstring(1.5,-3,'P3')
xstring(1.1,17,'P4')

// Scilab 5.26 ==========
w=logspace(-2,2,100);   // pg(0.01-100[rad/s])
Pall1=syslin('c',(5-s)/(s^2+2*s+5));   // `B֐
Pall2=syslin('c',(5+s)/(s^2+2*s+5));   // `B֐
bode_rs(Pall1,w)   // {[h}
bode_rs(Pall2,w)   // {[h}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";

caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

subplot(2,1,2)
xstring(11,-230,'Pall1')
xstring(11,-90,'Pall2')
