// 6́@tB[hobNn̈萫

// Scilab 6.1 ==========
P=10/((s+6)*(s+10));   // Ώ
K=3*(s+4)/s;   // 
Pcl=(P*K)/.(1);   // [v`B֐
roots(denom(Pcl))   // [vɂ̌vZ

// Scilab 6.2 ==========
L30=syslin('c',30/(s+1)^2/(s+4));   // k=30;
L100=syslin('c',100/(s+1)^2/(s+4));   // k=100;
nyquist(L30,-10,10);   // xNgO
nyquist(L100,-10,10);   // xNgO
xgrid(), xtitle('xNgO','','')
xset('font size',3)   // tHgTCY̎w

caxes=gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.x_location = "origin";   // x_
caxes.y_location = "origin";   // y_
caxes.isoview = "on";   // x y𓯈䗦ɂ
xstring(6,-7,"k=30")
xstring(15.5,-18,"k=100")

// Scilab 6.3 ==========
mtlb_axis([-2,2,-2,2]);
plot2d(-1,0,style=0)
xstring(-1.2,1.2,"k=30")
xstring(-1.9,0.3,"k=100")

// Scilab 6.4 ==========
roots(denom(L30/.(1)))   // k=30 ̂Ƃ̕[v
roots(denom(L100/.(1)))   // k=100 ̂Ƃ̕[v

// Scilab 6.6 ==========
L50=syslin('c',50/(s+1)^2/(s+4));   // k=50
t=0:0.01:10;   // V~[VԂ̐ݒ
syscl=L50/.(1);   // [v`B֐̌vZ
y=csim('impl',t,syscl);   // PʃCpX̌vZ
plot2d(t,y,axesflag=1)   // ̕\
xgrid(), xtitle('','time [s]','y')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

caxes = gca();   // nh̎擾
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.children.children.thickness = 2;   // ̑
caxes.box = "on";

// Scilab 6.7 ==========
denom(syscl)   // [v`B֐̕ꑽ
roots(ans)   // [v

// } 6.6 ==========
sysL=syslin('c',10*sqrt(5)/(s+1)^2/(s+4));   //@ꏄ`B֐
w=logspace(-1,1,100);
bode_rs(sysL,w)   // BODE}

subplot(2,1,1)
plot2d1('oln',[0.1,10],[0,0])
plot2d1('oln',[3,3],[0,-7])
subplot(2,1,2)
plot2d1('oln',[0.1,10],[-180,-180])
plot2d1('oln',[2,2],[-153.4,-180])

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children(1).thickness=2;   // ̑ 2
caxes1.children.children(2).thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";
caxes2=cfig.children(2);   // nh
caxes2.children.children(1).thickness=2;   // ̑ 2
caxes2.children.children(2).thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

subplot(2,1,1)
xstring(2,1,"wg"), xstring(3.1,-5,"Gm")
subplot(2,1,2)
xstring(3,-175,"wp"), xstring(1.5,-175,"Pm")

// Scilab 6.10 ==========
sysL=syslin('c',10*sqrt(5)/(s+1)^2/(s+4));   // ꏄ`B֐
g_margin(sysL)   // QC]T
p_margin(sysL)   // ʑ]T

// Scilab 6.11 ==========
show_margins(sysL)
   
// Scilab 6.12 ==========
chart(), xgrid()   // jRX}
w=logspace(-2,2,100);
repf=repfreq(sysL,w);   // g
[db,phi]=dbphi(repf);   // QCƈʑ̌vZ
plot2d(phi,db)   // QCEʑ}

// Scilab 6.13 ==========
sysL=syslin('c',10*sqrt(5)/(s+1)^2/(s+4));   // ꏄ`B֐
syscl=sysL/.(1);   // [v`B֐
w=logspace(-1,1,100);
bode_rs(syscl,w);   // BODE}

cfig=gcf();   // nh̎擾
caxes1=cfig.children(1);   // nh
caxes1.children.children.thickness=2;   // ̑ 2
caxes1.title.font_size = 3;   // ^Cg̃tHgTCY
caxes1.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes1.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes1.box = "on";
caxes2=cfig.children(2);   // nh
caxes2.children.children.thickness=2;   // ̑ 2
caxes2.title.font_size = 3;   // ^Cg̃tHgTCY
caxes2.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes2.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes2.box = "on";

// Scilab 6.16 ==========
da=s^5+9*s^4+32*s^3+56*s^2+47*s+15;   // 
routh_t(da)   // EX̌vZ
roots(da)'   // 

// Scilab 6.17 ==========
db=s^4+3*s^3+s^2+3*s+1;   // 
routh_t(db)   // EX
roots(db)'   // 

// Scilab 6.18 ==========
P=1/(s^2+6*s+5);   // `B֐
evans(P)   // O
xgrid(), xtitle('O','','')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
mtlb_axis([-6,2,-4,4]);

caxes = gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.x_location = "origin";   // x_
caxes.y_location = "origin";   // y_
caxes.children(1).visible="off";   // 
caxes.children(2).children.thickness = 2;   // ̑
caxes.children(2).children.foreground = 1;   // ̑
caxes.box = "on";
caxes.isoview = "on";   // x y𓯈䗦ɂ

// } 6.11 ==========
plot2d([-4,-15],[0,0],axesflag=1)
plot2d([-2,-2+15/sqrt(3)],[0,15])
plot2d([-2,-2+15/sqrt(3)],[0,-15])
plot2d([-4,-2],[0,0],style=-2)
xgrid(), xtitle('O','','')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
mtlb_axis([-15,15,-15,15]);

caxes = gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.x_location = "origin";   // x_
caxes.y_location = "origin";   // y_
caxes.children(2).children.thickness = 2;   // ̑
caxes.children(2).children.foreground = 1;   // ̑
caxes.children(3).children.thickness = 2;   // ̑
caxes.children(3).children.foreground = 1;   // ̑
caxes.children(4).children.thickness = 2;   // ̑
caxes.children(4).children.foreground = 1;   // ̑
caxes.box = "on";
caxes.isoview = "on";   // x y𓯈䗦ɂ

// Scilab 6.19 ==========
L=syslin('c',10*sqrt(5)/((s+1)^2*(s+4)));   // ꏄ`B֐ 
evans(L)   // O
xgrid(), xtitle('O','','')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
mtlb_axis([-15,15,-15,15]);

caxes = gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.x_location = "origin";   // x_
caxes.y_location = "origin";   // y_
caxes.children(1).visible="off";   // 
caxes.children(2).children.thickness = 2;   // ̑
caxes.children(2).children.foreground = 1;   // ̑
caxes.box = "on";
caxes.isoview = "on";   // x y𓯈䗦ɂ

// Scilab 6.20 ==========
num=10*sqrt(5); den=(s+1)^2*(s+4);
[klim,Y]=kpure(num/den)   // EQC
   
// Scilab 6.21 ==========
num=s+7; den=(s+1)*(s+4)*(s^2+10*s+128);
evans(syslin('c',num/den))
xgrid(), xtitle('O','','')   // ObhƎx
xset('font size',3)   // tHgTCY̎w
mtlb_axis([-20,20,-20,20]);

caxes = gca();   // nh̎擾
caxes.title.font_size = 3;   // ^Cg̃tHgTCY
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.x_location = "origin";   // x_
caxes.y_location = "origin";   // y_
caxes.children(1).visible="off";   // 
caxes.children(2).children.thickness = 2;   // ̑
caxes.children(2).children.foreground = 1;   // ̑
caxes.box = "on";
caxes.isoview = "on";   // x y𓯈䗦ɂ

[klim,Y]=kpure(num/den)   // EQC

