// 3́@VXe̎ԉƂ̕]

// Scilab 3.1 ==========
t=0:0.01:10;   // V~[V
P=syslin('c',10/(s^2+2*s+10));   // `B֐
x=csim(ones(t),t,P);   // PʃXebv
// x=csim('step',t,P);
plot2d(t,x,axesflag=1)   // \
xgrid(), xtitle('','time [s]','x')   // ObhƎx
xset('font size',3)   // tHgTCY̎w

caxes = gca();   // nh̎擾
caxes.x_label.font_size = 3;   // x̃x̃tHgTCY
caxes.y_label.font_size = 3;   // ỹx̃tHgTCY
caxes.children.children.thickness = 2;   // ̑

xstring(7,1.05,'퉞')   // ̕\
xstring(2,1.2,'ߓn')   // ̕\

// Scilab 3.4 ==========
t=0:0.01:4;   // V~[V
K=2; T=0.5;   // QCƎ萔
P1st=syslin('c',K/(1+T*s));   // 1VXeɑ΂`B֐
x1=csim(ones(t),t,P1st);   // PʃXebv
plot2d(t,x1,axesflag=1)   // \
xgrid(), xtitle('','time [s]','x')   // ObhƎx
plot2d(t,K/T*t)   // t=0 ɂڐ
plot2d(t,2*ones(t))   // l
mtlb_axis([0,4,0,2.5])   // ͈̔͂̐ݒ
xset('font size',3);   // tHgTCY̎w

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY
caxes.children(1).children.line_style = 3;   // C̏(_)
caxes.children(2).children.line_style = 3;   // C̏(_)
caxes.children.children.thickness = 2;   // ̑
caxes.box = "on";
   
// Scilab 3.7, 3.8, 3.9 ==========
// f[^̍쐬
tt = 0:0.2:3;
PP=syslin('c',2/(0.45*s+1));   // `B֐
xx=csim(ones(tt),tt,PP)+(rand(tt)-0.5)*0.2;   // f[^쐬
plot(tt,xx,'*')   // \
xgrid(), xtitle('','time [s]','x')   // ObhƎx
xset('font size',3);   // tHgTCY̎w
mtlb_axis([0,3,0,2.5])   // ͈̔͂̐ݒ

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY
caxes.box = "on";

// ֐̒`
function y = resp1(t,param)
  y = param(1)*(1-exp(-t/param(2)));
endfunction

function er = error_resp1(x,t,data)
  er = sum((resp1(t,x)-data).^2);
endfunction
   
// f[^̓ǂݍ݂ƍŏߎ
loadmatfile('c3_data1_t.txt','-ascii'); tt=c3_data1_t;
loadmatfile('c3_data1_x.txt','-ascii'); xx=c3_data1_x;
param0=[2,1];   // Tl
[fer,popt,gropt] = leastsq(list(error_resp1,tt,xx),param0)   // ŏ@

// ʂ̕\
t=0:0.01:3;   // V~[V
K=2.0041; T=0.47829;   // 茋
P1st=syslin('c',K/(1+T*s));   // `B֐
x1=csim(ones(t),t,P1st);   //@PʃXebv
plot2d(t,x1,axesflag=1)   // \
xset('font size',3);   // tHgTCY̎w
xgrid(), xtitle('','time [s]','x')   // ObhƎx
plot2d(tt,xx,style=-1)   // f[^̕\(㏑) 

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY   
caxes.box = "on";
mtlb_axis([0,3,0,2.5])
   
// Scilab 3.10 ==========
t=0:0.01:4;   // V~[V
K=2; om=3;   // QC wn
for zeta=0.1:0.2:1.1   // eĂɑ΂ĒPʃXebv̌vZ
  P2nd=syslin('c',K*om^2/(s^2+2*zeta*om*s+om^2));   // `B֐
  x=csim(ones(t),t,P2nd);   // PʃXebv
  plot2d(t,x,axesflag=1)   // ̕\(㏑)
end
xset('font size',3);   // tHgTCY̎w
xgrid(), xtitle('','time [s]','x')   // ObhƎx

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY
caxes.children.children.thickness = 2;   // ̑
caxes.box = "on";

xstring(1.3,3.1,'zeta=0.1')   // ̕\
xstring(1.1,2.7,'0.3')
xstring(1.1,2.35,'0.5')
xstring(1.1,2.1,'0.7')
xstring(1.1,1.8,'0.9')
xstring(1.1,1.5,'1.1')
   
// } 3.7 ==========
t=0:0.01:4;   // V~[V
K=2; om=3;   // p[^
zeta=0.5; P2nd=syslin('c',K*om^2/(s^2+2*zeta*om*s+om^2));   // `B֐
x=csim(ones(t),t,P2nd);   // PʃXebv
plot(t,x,'-k','thickness',3)   // ̕\
xset('font size',3);
xgrid(), xtitle('','time [s]','x')

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY
caxes.box = "on";

plot([1.5,4],[2*0.95,2*0.95],'k')   // 莞Ԃ̕]p
plot([1.5,4],[2*1.05,2*1.05],'k')   // 莞Ԃ̕]p

// Scilab 3.11 ==========
t=0:0.01:5;   // V~[V
P2nd=syslin('c',22.89/(s^2+4*s+11.44));   // 肵`B֐
x2=csim(ones(t),t,P2nd);   // PʃXebv
plot2d(t,x2,axesflag=1)   // \
xset('font size',3);   // tHgTCY̎w
xgrid(), xtitle('','time [s]','x')   // Obhƃ^Cg

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY
caxes.children.children.thickness = 2;   // ̑
caxes.box = "on";

plot2d([0,5],[2*1.018,2*1.018])   // ŏIl+1.8%
plot2d([0,5],[2*0.982,2*0.982])   // ŏIl-1.8%
plot2d(t,2+2*exp(-2*t)/sqrt(1-0.5912^2))   // 
plot2d(t,2-2*exp(-2*t)/sqrt(1-0.5912^2))   // 
mtlb_axis([0,5,0,2.5])   // ͈̔͂̐ݒ
   
// Scilab 3.12 ==========
t=0:0.01:5;   // V~[V
poles=[-1+20*im,-1-20*im,-8,-10];   // 
Pn=syslin('c',prod(-poles)/poly(poles,'s','roots'));   // `B֐
xn=csim(ones(t),t,Pn);   // PʃXebv
plot2d(t,xn,axesflag=1)   // \
xgrid(), xtitle('','time [s]','x')   // ObhƎx
xset('font size',3);   // tHgTCY

caxes=gca();   // nh̎擾
caxes.x_label.font_size = 3;   // xx̃tHgTCY
caxes.y_label.font_size = 3;   // yx̃tHgTCY
caxes.children.children.thickness = 2;   // ̑
caxes.box = "on";

x2=csim(ones(t),t,syslin('c',80/(s^2+18*s+80)));   // PʃXebv
plot2d(t,x2)   // ̕\
